package de.samdev.colorrunner.game.world.map;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import com.badlogic.gdx.Gdx;

public class CRMapStorage {
	public static final Random random = new Random();
	public static final List<CRTiledMap> maps = new ArrayList<CRTiledMap>();
	
	public static final CRTiledMap map_01 = register("p1.tmx");
	public static final CRTiledMap map_02 = register("p2.tmx");
	public static final CRTiledMap map_03 = register("p3.tmx");
	public static final CRTiledMap map_04 = register("p4.tmx");
	
	public static CRTiledMap register(String path) {
		CRTiledMap m = CRTiledMap.load(Gdx.files.internal("map_pieces/" + path).readString());
		maps.add(m);
		return m;
	}
	
	public static CRTiledMap getMap() {
		return maps.get(random.nextInt(maps.size()));
	}
}
